/*----- PROTECTED REGION ID(Tango2Epics.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tango2Epics.h
//
// description : Include file for the Tango2Epics class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: Vid Juvan $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Tango2Epics_H
#define Tango2Epics_H

#include <tango.h>
#include <unordered_map>
#include <string>
#include <vector>

#include <cadef.h>

#include "EpicsThreadHandler.h"




/*----- PROTECTED REGION END -----*/	//	Tango2Epics.h

/**
 *  Tango2Epics class description:
 *    A device can be integrated in Tango control system by developing a 
 *    specific Tango device server software for the device. In situations when
 *    the Tango device server software is not available for the device, 
 *    but software support for the EPICS control system is available instead, 
 *    it is possible to use the Tango2Epics Tango device server to expose 
 *    the device in Tango system. It serves as a bridge, in form of a Tango device, 
 *    to EPICS control system. PVaccess device exposes the existing EPICS 
 *    Process Variables (PVs) of the device in form of Tango device attributes, 
 *    states, and emulates a preconfigured set of Tango device commands by 
 *    using the appropriate EPICS PVs. By using the Tango2Epics Tango device, 
 *    integration can be achieved through configuration only, with no development 
 *    required. More information can be found in the user manual, located: 
 *    http://sourceforge.net/p/tango-ds/code/HEAD/tree/DeviceClasses/Communication/Tango2Epics/trunk/doc/Tango2EpicsGateway.pdf.
 */

namespace Tango2Epics_ns
{
/*----- PROTECTED REGION ID(Tango2Epics::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
class PvAccessException: public std::exception{
public:

    explicit PvAccessException(const char* message):msg(message){}

    explicit PvAccessException(const std::string& message):msg(message){}

    virtual ~PvAccessException() throw (){}

    virtual const char* what() const throw (){
       return msg.c_str();
    }

protected:
    std::string msg;
};

#include <PvAttribute.h>
#include <PvCommand.h>
#include <PvState.h>

/*----- PROTECTED REGION END -----*/	//	Tango2Epics::Additional Class Declarations

class Tango2Epics : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Tango2Epics::Data Members) ENABLED START -----*/

//	Add your own data members
public:

	typedef struct{
		Tango::DevState state;
		std::string value;
	}STATE_MAP_LOGIC;

	std::vector<PvBasicCommand*> pvOn;
	std::vector<PvBasicCommand*> pvOff;
	std::vector<PvBasicCommand*> pvReset;

	//only one PvState per PV possible
	std::map<std::string, PvBasicState*> pvState;
	//Mutex for serializing state changes.
	pthread_mutex_t state_mutex = PTHREAD_MUTEX_INITIALIZER;

	EpicsThreadHandler* threadHandler;

/*----- PROTECTED REGION END -----*/	//	Tango2Epics::Data Members

//	Device property data members
public:
	//	Variables:	This is the property, that defines which PVs will be linked to what 
	//  Tango attributes, commands or states. It consists of multiple items, 
	//  each specifying one PV and its properties. Additionally it provides 
	//  the configuration for linking the PV to the Tango attributes, 
	//  commands or states. See the Extended BNF Format of device properties
	//  in the user manual for the format of this property and its items.
	vector<string>	variables;
	//	ScalarAccessTimeout:	This property specifies the value of the preferred timeout 
	//  (in seconds) for when trying to access a scalar PV.
	Tango::DevDouble	scalarAccessTimeout;
	//	ArrayAccessTimeout:	This property specifies the value of the preferred timeout 
	//  (in seconds) for when trying to access a array PV.
	Tango::DevDouble	arrayAccessTimeout;
	//	SubscriptionCycle:	This property specifies the value of the time period for subscription 
	//  cycles. Note: when closing the application, it might take one 
	//  subscription cycle period of time to close the subscriptions.
	Tango::DevDouble	subscriptionCycle;
	//	AlwaysUpdateSetpoints:	
	Tango::DevBoolean	alwaysUpdateSetpoints;


//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tango2Epics(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tango2Epics(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Tango2Epics(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Tango2Epics() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Tango2Epics::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);


	//--------------------------------------------------------
	/**
	 *	Method      : Tango2Epics::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command On related method
	 *	Description: Allegedly represents a command for turning the device on. 
	 *               It changes the values of specified PVs to the specified value. 
	 *               Specifications about these actions are read from the Variable 
	 *               device property. See the user manual for details on 
	 *               configuration.
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);
	/**
	 *	Command Off related method
	 *	Description: Allegedly represents a command for turning the device off. 
	 *               It changes the values of specified PVs to the specified value. 
	 *               Specifications about these actions are read from the Variable 
	 *               device property. See the user manual for details on 
	 *               configuration.
	 *
	 */
	virtual void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *	Description: Allegedly represents a command for reseting the device. 
	 *               It changes the values of specified PVs to the specified value. 
	 *               Specifications about these actions are read from the Variable 
	 *               device property. See the user manual for details on 
	 *               configuration.
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command ResetSetpoint related method
	 *	Description: Force setpoint update (for Read_Write attribute)
	 *
	 */
	virtual void reset_setpoint();
	virtual bool is_ResetSetpoint_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : Tango2Epics::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Tango2Epics::Additional Method prototypes) ENABLED START -----*/

	std::vector<STATE_MAP_LOGIC> parseStateMapLogic(std::string map_logic);
  template<typename T> void initSetpoint(Tango::Attr * attr);


/*----- PROTECTED REGION END -----*/	//	Tango2Epics::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Tango2Epics::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Tango2Epics::Additional Classes Definitions

}	//	End of namespace

#endif   //	Tango2Epics_H
